info = {
    'icon' : 'LINENUMBERS_ON',
    'description' : 'Note and render',
    'render' : False,
}


import bpy
import os
from os import listdir
from os.path import join, dirname, basename, exists, isfile, isdir, splitext
import re, fnmatch, glob
from mathutils import Vector, Matrix
from math import radians, degrees
C = bpy.context
D = bpy.data
scene = C.scene

print('====')

scene.render.use_stamp_note = True

dist = scene.eevee.gtao_distance
fac = scene.eevee.gtao_factor
print('dist: ', dist)
print('fac: ', fac)

dist = round(dist, 2)
fac = round(fac, 2)

scene.render.stamp_note_text = f'AO dist {dist} fac {fac}'

if scene.view_settings.look != 'Filmic - Medium Contrast':
    scene.render.stamp_note_text += f' - {scene.view_settings.look}'


org = scene.render.filepath
print(f'filepath was : {org}')

## full filename
# scene.render.filepath = join(dirname(D.filepath), f'{splitext(basename(D.filepath))[0]}-{scene.frame_current}_AO-dist{dist}-fac{fac}')

## custom filename
ep = int(re.search(r"(\d{3})", splitext(basename(D.filepath))[0]).group(1))
print('ep: ', ep)
scene.render.filepath = join(dirname(D.filepath), f'twu_{ep}-{scene.frame_current}_AO-dist{dist}-fac{fac}')

i = 2#increment if needed
while exists(scene.render.filepath + '.png'):
    scene.render.filepath = join(dirname(D.filepath), f'twu_{ep}-{scene.frame_current}_AO-dist{dist}-fac{fac}_{i}')

if info['render']:
    bpy.ops.render.render(animation=False, write_still=True)
    # restore old sauce ?
    scene.render.filepath = org

print('done')

